diff -ruNp linux-2.6.26.1/arch/x86/ia32/ia32_aout.c linux-2.6.26.1-cher1/arch/x86/ia32/ia32_aout.c
--- linux-2.6.26.1/arch/x86/ia32/ia32_aout.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/arch/x86/ia32/ia32_aout.c	2008-08-05 13:44:37.000000000 +0400
@@ -298,8 +298,12 @@ static int load_aout_binary(struct linux
 	rlim = current->signal->rlim[RLIMIT_DATA].rlim_cur;
 	if (rlim >= RLIM_INFINITY)
 		rlim = ~0;
-	if (ex.a_data + ex.a_bss > rlim)
+	if (ex.a_data + ex.a_bss > rlim) {
+                if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+                        current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+                }
 		return -ENOMEM;
+        }
 
 	/* Flush all traces of the currently running executable */
 	retval = flush_old_exec(bprm);
@@ -545,3 +549,9 @@ static void __exit exit_aout_binfmt(void
 module_init(init_aout_binfmt);
 module_exit(exit_aout_binfmt);
 MODULE_LICENSE("GPL");
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/arch/x86/ia32/ia32_signal.c linux-2.6.26.1-cher1/arch/x86/ia32/ia32_signal.c
--- linux-2.6.26.1/arch/x86/ia32/ia32_signal.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/arch/x86/ia32/ia32_signal.c	2008-08-05 13:44:37.000000000 +0400
@@ -119,6 +119,9 @@ int copy_siginfo_from_user32(siginfo_t *
 
 asmlinkage long sys32_sigsuspend(int history0, int history1, old_sigset_t mask)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	mask &= _BLOCKABLE;
 	spin_lock_irq(&current->sighand->siglock);
 	current->saved_sigmask = current->blocked;
diff -ruNp linux-2.6.26.1/arch/x86/ia32/ipc32.c linux-2.6.26.1-cher1/arch/x86/ia32/ipc32.c
--- linux-2.6.26.1/arch/x86/ia32/ipc32.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/arch/x86/ia32/ipc32.c	2008-08-05 13:44:37.000000000 +0400
@@ -14,6 +14,11 @@ asmlinkage long sys32_ipc(u32 call, int 
 {
 	int version;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	version = call >> 16; /* hack for backward compatibility */
 	call &= 0xffff;
 
@@ -51,3 +56,9 @@ asmlinkage long sys32_ipc(u32 call, int 
 	}
 	return -ENOSYS;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/arch/x86/ia32/sys_ia32.c linux-2.6.26.1-cher1/arch/x86/ia32/sys_ia32.c
--- linux-2.6.26.1/arch/x86/ia32/sys_ia32.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/arch/x86/ia32/sys_ia32.c	2008-08-05 13:44:37.000000000 +0400
@@ -134,8 +134,12 @@ asmlinkage long sys32_stat64(char __user
 			     struct stat64 __user *statbuf)
 {
 	struct kstat stat;
-	int ret = vfs_stat(filename, &stat);
+	int ret;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
 
+        ret = vfs_stat(filename, &stat);
 	if (!ret)
 		ret = cp_stat64(statbuf, &stat);
 	return ret;
@@ -145,7 +149,12 @@ asmlinkage long sys32_lstat64(char __use
 			      struct stat64 __user *statbuf)
 {
 	struct kstat stat;
-	int ret = vfs_lstat(filename, &stat);
+	int ret;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        ret = vfs_lstat(filename, &stat);
 	if (!ret)
 		ret = cp_stat64(statbuf, &stat);
 	return ret;
@@ -154,7 +163,12 @@ asmlinkage long sys32_lstat64(char __use
 asmlinkage long sys32_fstat64(unsigned int fd, struct stat64 __user *statbuf)
 {
 	struct kstat stat;
-	int ret = vfs_fstat(fd, &stat);
+	int ret;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        ret = vfs_fstat(fd, &stat);
 	if (!ret)
 		ret = cp_stat64(statbuf, &stat);
 	return ret;
@@ -166,6 +180,9 @@ asmlinkage long sys32_fstatat(unsigned i
 	struct kstat stat;
 	int error = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if ((flag & ~AT_SYMLINK_NOFOLLOW) != 0)
 		goto out;
 
@@ -238,6 +255,9 @@ asmlinkage long sys32_pipe(int __user *f
 	int retval;
 	int fds[2];
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	retval = do_pipe(fds);
 	if (retval)
 		goto out;
@@ -371,6 +391,9 @@ asmlinkage long sys32_rt_sigprocmask(int
 	int ret;
 	mm_segment_t old_fs = get_fs();
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (set) {
 		if (copy_from_user(&s32, set, sizeof(compat_sigset_t)))
 			return -EFAULT;
@@ -457,6 +480,11 @@ asmlinkage long sys32_settimeofday(struc
 	struct timespec kts;
 	struct timezone ktz;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (tv) {
 		if (get_tv32(&ktv, tv))
 			return -EFAULT;
@@ -525,6 +553,9 @@ asmlinkage long sys32_rt_sigpending(comp
 	int ret;
 	mm_segment_t old_fs = get_fs();
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	set_fs(KERNEL_DS);
 	ret = sys_rt_sigpending((sigset_t __user *)&s, sigsetsize);
 	set_fs(old_fs);
@@ -548,6 +579,9 @@ asmlinkage long sys32_rt_sigqueueinfo(in
 	int ret;
 	mm_segment_t old_fs = get_fs();
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (copy_siginfo_from_user32(&info, uinfo))
 		return -EFAULT;
 	set_fs(KERNEL_DS);
@@ -586,6 +620,11 @@ asmlinkage long sys32_sysctl(struct sysc
 	int __user *namep;
 	long ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (copy_from_user(&a32, args32, sizeof(a32)))
 		return -EFAULT;
 
@@ -657,6 +696,9 @@ asmlinkage long sys32_sendfile(int out_f
 	int ret;
 	off_t of;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (offset && get_user(of, offset))
 		return -EFAULT;
 
@@ -752,6 +794,9 @@ long sys32_ustat(unsigned dev, struct us
 	mm_segment_t seg;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	seg = get_fs();
 	set_fs(KERNEL_DS);
 	ret = sys_ustat(dev, (struct ustat __user *)&u);
@@ -774,11 +819,20 @@ asmlinkage long sys32_execve(char __user
 	long error;
 	char *filename;
 
+        if ((current->sbox_flags & SBOX_NO_EXEC)) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	filename = getname(name);
 	error = PTR_ERR(filename);
 	if (IS_ERR(filename))
 		return error;
 	error = compat_do_execve(filename, argv, envp, regs);
+        if (error == 0) {
+                if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                        current->sbox_flags |= SBOX_NO_EXEC;
+        }
 	putname(filename);
 	return error;
 }
@@ -822,6 +876,11 @@ long sys32_vm86_warning(void)
 	struct task_struct *me = current;
 	static char lastcomm[sizeof(me->comm)];
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (strncmp(lastcomm, me->comm, sizeof(lastcomm))) {
 		compat_printk(KERN_INFO
 			      "%s: vm86 mode not supported on 64 bit kernel\n",
@@ -865,3 +924,9 @@ asmlinkage long sys32_fallocate(int fd, 
 	return sys_fallocate(fd, mode, ((u64)offset_hi << 32) | offset_lo,
 			     ((u64)len_hi << 32) | len_lo);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/arch/x86/kernel/ioport.c linux-2.6.26.1-cher1/arch/x86/kernel/ioport.c
--- linux-2.6.26.1/arch/x86/kernel/ioport.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/arch/x86/kernel/ioport.c	2008-08-05 13:44:37.000000000 +0400
@@ -38,6 +38,11 @@ asmlinkage long sys_ioperm(unsigned long
 	struct tss_struct * tss;
 	unsigned int i, max_long, bytes, bytes_updated;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if ((from + num <= from) || (from + num > IO_BITMAP_BITS))
 		return -EINVAL;
 	if (turn_on && !capable(CAP_SYS_RAWIO))
@@ -137,6 +142,11 @@ asmlinkage long sys_iopl(unsigned long r
 	struct thread_struct *t = &current->thread;
 	int rc;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	rc = do_iopl(level, regs);
 	if (rc < 0)
 		goto out;
@@ -149,6 +159,17 @@ out:
 #else
 asmlinkage long sys_iopl(unsigned int level, struct pt_regs *regs)
 {
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	return do_iopl(level, regs);
 }
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/arch/x86/kernel/ldt.c linux-2.6.26.1-cher1/arch/x86/kernel/ldt.c
--- linux-2.6.26.1/arch/x86/kernel/ldt.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/arch/x86/kernel/ldt.c	2008-08-05 13:44:37.000000000 +0400
@@ -243,6 +243,11 @@ asmlinkage int sys_modify_ldt(int func, 
 {
 	int ret = -ENOSYS;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	switch (func) {
 	case 0:
 		ret = read_ldt(ptr, bytecount);
@@ -259,3 +264,9 @@ asmlinkage int sys_modify_ldt(int func, 
 	}
 	return ret;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/arch/x86/kernel/process_32.c linux-2.6.26.1-cher1/arch/x86/kernel/process_32.c
--- linux-2.6.26.1/arch/x86/kernel/process_32.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/arch/x86/kernel/process_32.c	2008-08-05 13:44:37.000000000 +0400
@@ -711,6 +711,11 @@ asmlinkage int sys_execve(struct pt_regs
 	int error;
 	char * filename;
 
+        if ((current->sbox_flags & SBOX_NO_EXEC)) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	filename = getname((char __user *) regs.bx);
 	error = PTR_ERR(filename);
 	if (IS_ERR(filename))
@@ -720,6 +725,8 @@ asmlinkage int sys_execve(struct pt_regs
 			(char __user * __user *) regs.dx,
 			&regs);
 	if (error == 0) {
+                if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                        current->sbox_flags |= SBOX_NO_EXEC;
 		/* Make sure we don't return using sysenter.. */
 		set_thread_flag(TIF_IRET);
 	}
@@ -767,3 +774,9 @@ unsigned long arch_randomize_brk(struct 
 	unsigned long range_end = mm->brk + 0x02000000;
 	return randomize_range(mm->brk, range_end, 0) ? : mm->brk;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/arch/x86/kernel/process_64.c linux-2.6.26.1-cher1/arch/x86/kernel/process_64.c
--- linux-2.6.26.1/arch/x86/kernel/process_64.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/arch/x86/kernel/process_64.c	2008-08-05 13:44:37.000000000 +0400
@@ -678,11 +678,20 @@ long sys_execve(char __user *name, char 
 	long error;
 	char * filename;
 
+        if ((current->sbox_flags & SBOX_NO_EXEC)) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	filename = getname(name);
 	error = PTR_ERR(filename);
 	if (IS_ERR(filename))
 		return error;
 	error = do_execve(filename, argv, envp, regs);
+        if (error == 0) {
+                if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                        current->sbox_flags |= SBOX_NO_EXEC;
+        }
 	putname(filename);
 	return error;
 }
@@ -868,3 +877,9 @@ unsigned long arch_randomize_brk(struct 
 	unsigned long range_end = mm->brk + 0x02000000;
 	return randomize_range(mm->brk, range_end, 0) ? : mm->brk;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/arch/x86/kernel/signal_32.c linux-2.6.26.1-cher1/arch/x86/kernel/signal_32.c
--- linux-2.6.26.1/arch/x86/kernel/signal_32.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/arch/x86/kernel/signal_32.c	2008-08-05 13:44:37.000000000 +0400
@@ -48,6 +48,9 @@
 asmlinkage int
 sys_sigsuspend(int history0, int history1, old_sigset_t mask)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	mask &= _BLOCKABLE;
 	spin_lock_irq(&current->sighand->siglock);
 	current->saved_sigmask = current->blocked;
@@ -672,3 +675,9 @@ do_notify_resume(struct pt_regs *regs, v
 
 	clear_thread_flag(TIF_IRET);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/arch/x86/kernel/sys_i386_32.c linux-2.6.26.1-cher1/arch/x86/kernel/sys_i386_32.c
--- linux-2.6.26.1/arch/x86/kernel/sys_i386_32.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/arch/x86/kernel/sys_i386_32.c	2008-08-05 13:44:37.000000000 +0400
@@ -108,6 +108,11 @@ asmlinkage int sys_ipc (uint call, int f
 {
 	int version, ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	version = call >> 16; /* hack for backward compatibility */
 	call &= 0xffff;
 
@@ -244,3 +249,9 @@ int kernel_execve(const char *filename, 
 	: "0" (__NR_execve),"ri" (filename),"c" (argv), "d" (envp) : "memory");
 	return __res;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/arch/x86/kernel/vm86_32.c linux-2.6.26.1-cher1/arch/x86/kernel/vm86_32.c
--- linux-2.6.26.1/arch/x86/kernel/vm86_32.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/arch/x86/kernel/vm86_32.c	2008-08-05 13:44:37.000000000 +0400
@@ -207,6 +207,11 @@ asmlinkage int sys_vm86old(struct pt_reg
 	struct task_struct *tsk;
 	int tmp, ret = -EPERM;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	tsk = current;
 	if (tsk->thread.saved_sp0)
 		goto out;
@@ -237,6 +242,11 @@ asmlinkage int sys_vm86(struct pt_regs r
 	int tmp, ret;
 	struct vm86plus_struct __user *v86;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	tsk = current;
 	switch (regs.bx) {
 	case VM86_REQUEST_IRQ:
@@ -835,3 +845,8 @@ static int do_vm86_irq_handling(int subf
 	return -EINVAL;
 }
 
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
